# $Id: xchain-kernel.make,v 0.3.2.1 2002/09/12 11:00:00 robert Exp $
#
# (c) 2002 by Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
ifeq (y,$(PTXCONF_KERNEL_2_4_18))
PACKAGES += xchain-kernel
endif
ifeq (y,$(PTXCONF_KERNEL_2_4_19))
PACKAGES += xchain-kernel
endif

#
# Paths and names 
#
# FIXME: make extraversion configurable!
# 
ifeq (y,$(PTXCONF_KERNEL_2_4_18))
KERNEL			= linux-2.4.18
KERNEL_URL		= ftp://ftp.kernel.org/pub/linux/kernel/v2.4/$(KERNEL).tar.bz2 
KERNEL_SOURCE		= $(SRCDIR)/$(KERNEL).tar.bz2
KERNEL_DIR		= $(BUILDDIR)/$(KERNEL)
KERNEL_EXTRACT 		= bzip2 -dc

KERNEL_RMKPATCH		= patch-2.4.18-rmk7
KERNEL_RMKPATCH_URL	= ftp://ftp.arm.linux.org.uk/pub/armlinux/kernel/v2.4/$(KERNEL_RMKPATCH).bz2
KERNEL_RMKPATCH_SOURCE	= $(SRCDIR)/$(KERNEL_RMKPATCH).bz2
KERNEL_RMKPATCH_DIR	= $(BUILDDIR)/$(KERNEL)
KERNEL_RMKPATCH_EXTRACT	= bzip2 -dc

KERNEL_PTXPATCH		= patch-2.4.18-rmk7-ptx3
KERNEL_PTXPATCH_SOURCE	= $(SRCDIR)/$(KERNEL_PTXPATCH)
KERNEL_PTXPATCH_URL	= http://www.pengutronix.de/software/dnp/patch-2.4.18-rmk7-ptx3
KERNEL_PTXPATCH_DIR	= $(BUILDDIR)/$(KERNEL)
KERNEL_PTXPATCH_EXTRACT	= cat

ifeq (y, $(PTXCONF_RTAI_ALLSOFT))
KERNEL_RTAIPATCH	= patch-2.4.18-allsoft
endif
ifeq (y, $(PTXCONF_RTAI_RTHAL))
KERNEL_RTAIPATCH	= patch-2.4.18-rthal5g
endif
KERNEL_RTAIPATCH_SOURCE	= $(RTAI_DIR)/patches/$(KERNEL_RTAIPATCH)
KERNEL_RTAIPATCH_EXTRACT= cat
endif

ifeq (y,$(PTXCONF_KERNEL_2_4_19))
KERNEL			= linux-2.4.19
KERNEL_URL		= ftp://ftp.rfc822.org/pub/linux/kernel/v2.4/$(KERNEL).tar.bz2 
KERNEL_SOURCE		= $(SRCDIR)/$(KERNEL).tar.bz2
KERNEL_DIR		= $(BUILDDIR)/$(KERNEL)
KERNEL_EXTRACT 		= bzip2 -dc

KERNEL_RMKPATCH		= patch-2.4.19-rmk2
KERNEL_RMKPATCH_URL	= ftp://ftp.arm.linux.org.uk/pub/armlinux/kernel/v2.4/$(KERNEL_RMKPATCH).bz2
KERNEL_RMKPATCH_SOURCE	= $(SRCDIR)/$(KERNEL_RMKPATCH).bz2
KERNEL_RMKPATCH_DIR	= $(BUILDDIR)/$(KERNEL)
KERNEL_RMKPATCH_EXTRACT	= bzip2 -dc

KERNEL_PTXPATCH		= "FIXME_not_yet_ported" # patch-2.4.19-rmk2-ptxFIXME
KERNEL_PTXPATCH_SOURCE	= $(SRCDIR)/$(KERNEL_PTXPATCH)
KERNEL_PTXPATCH_URL	= http://www.pengutronix.de/software/dnp/patch-2.4.19-rmk2-ptxFIXME
KERNEL_PTXPATCH_DIR	= $(BUILDDIR)/$(KERNEL)
KERNEL_PTXPATCH_EXTRACT	= cat

ifeq (y, $(PTXCONF_RTAI_ALLSOFT))
KERNEL_RTAIPATCH	= patch-2.4.19-allsoft
endif
ifeq (y, $(PTXCONF_RTAI_RTHAL))
KERNEL_RTAIPATCH	= patch-2.4.19-rthal5g
endif
KERNEL_RTAIPATCH_SOURCE	= $(RTAI_DIR)/patches/$(KERNEL_RTAIPATCH)
KERNEL_RTAIPATCH_EXTRACT= cat
endif

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

xchain-kernel_get: $(STATEDIR)/xchain-kernel.get

xchain-kernel_get_deps =  $(KERNEL_SOURCE)
ifeq (y,$(PTXCONF_ARCH_ARM))
xchain-kernel_get_deps += $(KERNEL_RMKPATCH_SOURCE)
xchain-kernel_get_deps += $(KERNEL_PTXPATCH_SOURCE)
endif

$(STATEDIR)/xchain-kernel.get: $(xchain-kernel_get_deps)
	touch $@

$(KERNEL_SOURCE):
	@echo
	@echo ----------------- 
	@echo xchain-kernel.get
	@echo -----------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(KERNEL_URL)

$(KERNEL_RMKPATCH_SOURCE):
	@echo
	@echo -------------------------- 
	@echo xchain-kernel-armpatch.get
	@echo --------------------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(KERNEL_RMKPATCH_URL)

$(KERNEL_PTXPATCH_SOURCE):
	@echo
	@echo -------------------------- 
	@echo xchain-kernel-ptxpatch.get
	@echo --------------------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(KERNEL_PTXPATCH_URL)


# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

xchain-kernel_extract: $(STATEDIR)/xchain-kernel.extract

xchain-kernel_extract_deps =  $(STATEDIR)/xchain-kernel.get
ifeq (y,$(PTXCONF_RTAI))
xchain-kernel_extract_deps += $(STATEDIR)/rtai.extract
endif

$(STATEDIR)/xchain-kernel.extract: $(xchain-kernel_extract_deps)
	@echo
	@echo --------------------- 
	@echo xchain-kernel.extract
	@echo ---------------------
	@echo
	$(KERNEL_EXTRACT) $(KERNEL_SOURCE) | tar -C $(BUILDDIR) -xf -
	#
	# kernels before 2.4.19 extract to "linux" instead of "linux-version"
	#
        ifeq (y,$(PTXCONF_KERNEL_2_4_18))
	cd $(BUILDDIR) && mv linux $(KERNEL_DIR)
        endif
	#
	# patches for ARM
	#
        ifeq (y,$(PTXCONF_ARCH_ARM))
	cd $(KERNEL_DIR) && 						\
		$(KERNEL_RMKPATCH_EXTRACT) $(KERNEL_RMKPATCH_SOURCE) |  \
		patch -p1
	cd $(KERNEL_DIR) && 						\
		$(KERNEL_PTXPATCH_EXTRACT) $(KERNEL_PTXPATCH_SOURCE) |	\
		patch -p1
        endif
	#
	# patches for x86
	#
        ifeq (y,$(PTXCONF_ARCH_X86))
        ifeq (y,$(PTXCONF_RTAI))
	cd $(KERNEL_DIR) && 						\
		$(KERNEL_RTAIPATCH_EXTRACT) $(KERNEL_RTAIPATCH_SOURCE) |\
		patch -p1
        endif
        endif
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

xchain-kernel_prepare: $(STATEDIR)/xchain-kernel.prepare

ifeq (y,$(PTXCONF_ARCH_ARM))
KERNEL_ENVIRONMENT = PATH=$(PTXCONF_PREFIX)/bin:$$PATH
endif

$(STATEDIR)/xchain-kernel.prepare: $(STATEDIR)/xchain-kernel.extract
	@echo
	@echo -------------- 
	@echo KERNEL.prepare
	@echo --------------
	@echo
        ifeq (y,$(PTXCONF_BUILD_CROSSCHAIN))
	echo -n 'Please supply root password for sudo: '
	[ -d $(PTXCONF_PREFIX) ] || 				\
		$(SUDO) install -g wheel -m 0755 -o $(PTXUSER)  	\
				-d $(PTXCONF_PREFIX)
        endif
	cp $(TOPDIR)/config/kernel/config $(KERNEL_DIR)/.config	
        ifeq (y,$(PTXCONF_ARCH_ARM))
	perl -p -i -e 's/^ARCH := .*/ARCH := arm/' $(KERNEL_DIR)/Makefile
	perl -p -i -e 's/^CROSS_COMPILE .*/CROSS_COMPILE   = arm-linux-/' $(KERNEL_DIR)/Makefile
        endif
	PATH=$(PTXCONF_PREFIX)/bin:$$PATH 			\
		make -C $(KERNEL_DIR) oldconfig dep
#	ifeq (y,$(PTXCONF_BUILD_CROSSCHAIN))
#	# copy some header files 
#	cp -f 	$(KERNEL_DIR)/include/linux/version.h			\
#		$(PTXCONF_PREFIX)/asm-arm/include/linux/	
#	endif
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

xchain-kernel_compile: $(STATEDIR)/xchain-kernel.compile

$(STATEDIR)/xchain-kernel.compile: $(STATEDIR)/xchain-kernel.prepare 
	@echo
	@echo --------------------- 
	@echo xchain-kernel.prepare
	@echo ---------------------
	@echo
	$(KERNEL_ENVIRONMENT) make -C $(KERNEL_DIR) oldconfig dep clean bzImage modules
	touch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

xchain-kernel_install: $(STATEDIR)/xchain-kernel.install

$(STATEDIR)/xchain-kernel.install: $(STATEDIR)/xchain-kernel.compile
	@echo
	@echo --------------------- 
	@echo xchain-kernel.install
	@echo ---------------------
	@echo
	touch $@

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

xchain-kernel_targetinstall: $(STATEDIR)/xchain-kernel.targetinstall

$(STATEDIR)/xchain-kernel.targetinstall: $(STATEDIR)/xchain-kernel.install
	@echo
	@echo --------------------------- 
	@echo xchain-kernel.targetinstall
	@echo ---------------------------
	@echo
	mkdir -p $(ROOTDIR)/boot
	#
	# FIXME: we need to change the name to reflect the kernel version
	# FIXME: change this to be architecture independend
        ifeq (y,$(PTXCONF_ARCH_X86))
	cp $(KERNEL_DIR)/arch/i386/boot/bzImage $(ROOTDIR)/boot
        endif
        ifeq (y,$(PTXCONF_ARCH_ARM))
	cp $(KERNEL_DIR)/arch/arm/boot/zImage $(ROOTDIR)/boot
        endif
	$(KERNEL_ENVIRONMENT) make -C $(KERNEL_DIR) modules_install INSTALL_MOD_PATH=$(ROOTDIR)
	#
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

xchain-kernel_clean: 
	rm -rf $(STATEDIR)/xchain-kernel.* $(KERNEL_DIR)

# vim: syntax=make
